<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins';

export default Vue.extend({
  name: 'FifteenHero',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
});
</script>

<template>
  <section
    class="fifteen-hero fifteen-hero__background"
    :class="{
      'fifteen-hero--large': data.title.image?.url,
      'fifteen-hero--seventeen fifteen-hero__background--seventeen':
        data.seventeen,
    }"
    :style="
      isMobile && data.seventeen
        ? `background-image: url(${data.background_mobile});`
        : `background-image: url(${data.background});`
    "
  >
    <SlpContainer>
      <SlpRow
        class="fifteen-hero__row"
        :class="{ 'fifteen-hero__row--seventeen': data.seventeen }"
      >
        <SlpColumn
          :cols="6"
          class="slp-flex slp-justify-content-center slp-align-items-center slp-mb-24"
        ></SlpColumn>
        <SlpColumn
          :cols="data.seventeen ? 9 : 6"
          class="slp-flex slp-align-items-center slp-mb-24"
          :class="
            data.seventeen
              ? 'slp-justify-content-start'
              : 'slp-justify-content-center'
          "
        >
          <div v-if="data.title?.image?.url" class="fifteen-hero__title-image">
            <nuxt-img
              class="fifteen-hero__image"
              :src="data.title.image.url"
              :alt="data.title.image.alt"
              loading="lazy"
              data-aos="fade-up"
              data-aos-duration="600"
              width="512"
              format="webp"
              quality="99"
            />
          </div>
          <div
            class="fifteen-hero__body"
            :class="{ 'fifteen-hero__body--seventeen': data.seventeen }"
          >
            <SlpTypography
              v-if="data.title.note"
              class="slp-mb-8 fifteen-hero__note"
              tag="h5"
              variant="heading5-bold"
              data-aos="fade-down"
              data-aos-duration="600"
              >{{ data.title.note }}
            </SlpTypography>
            <SlpTypography
              v-if="data.title.text"
              class="slp-mb-32 slp-color-primary-300 fifteen-hero__header"
              :class="{ 'fifteen-hero__header--seventeen': data.seventeen }"
              tag="h1"
              :variant="
                data.seventeen && !isMobile ? 'display1-bold' : 'heading1'
              "
              data-aos="fade-up"
              data-aos-duration="600"
              >{{ data.title.text }}
            </SlpTypography>
            <SlpTypography
              tag="h2"
              class="slp-color-primary-300 slp-mb-32"
              :class="{ 'fifteen-hero__subtitle--seventeen': data.seventeen }"
              :variant="data.seventeen ? 'heading5' : 'heading4'"
              data-aos="fade-up"
              data-aos-duration="800"
              >{{ data.subtitle }}
            </SlpTypography>
            <SlpButton
              v-if="data.action"
              :variant="data.action.variant ?? 'ghost'"
              :class="
                data.action.variant
                  ? ''
                  : 'fifteen-hero__action slp-color-primary-300'
              "
              :href="data.action.url"
              :data-ga-name="data.action.data_ga_name"
              :data-ga-location="data.action.data_ga_location"
              data-aos="fade-up"
              data-aos-duration="1000"
            >
              <SlpTypography class="slp-flex" tag="span" variant="body1-bold">
                {{ data.action.text }}
                <SlpIcon
                  class="slp-ml-8"
                  :name="data.action?.icon?.name || 'chevron-lg-right'"
                  :variant="data.action?.icon?.variant || 'product'"
                  alt="Chevron Right Icon"
                />
              </SlpTypography>
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn
          :cols="data.seventeen ? 3 : 6"
          class="slp-flex slp-justify-content-center slp-align-items-center"
          data-aos="fade-left"
          data-aos-duration="1200"
        >
          <nuxt-img
            v-if="data.image && !data.seventeen"
            class="fifteen-hero__image"
            :class="{ 'fifteen-hero__image--seventeen': data.seventeen }"
            :src="data.image.url"
            :alt="data.image.alt"
            loading="lazy"
            format="webp"
            quality="99"
          />
          <nuxt-img
            v-else-if="data.image && data.seventeen && !isMobile"
            class="fifteen-hero__image"
            :class="{ 'fifteen-hero__image--seventeen': data.seventeen }"
            :src="data.image.url"
            :alt="data.image.alt"
            loading="lazy"
            format="webp"
            quality="99"
          />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.fifteen-hero {
  min-height: 55rem;
  height: 55rem;
  position: relative;
  margin-bottom: $spacing-16;
  display: flex;
  align-items: center;

  @media (min-width: $breakpoint-md) {
    margin-bottom: $spacing-96;
    min-height: 45rem;
    height: 45rem;
  }

  &--seventeen {
    min-height: 65rem;
    height: 65rem;

    @media (min-width: $breakpoint-md) {
      margin-bottom: 0;
      min-height: 55rem;
      height: 55rem;
    }

    @media (min-width: $breakpoint-sm) and (max-width: $breakpoint-md) {
      margin-bottom: 0;
      min-height: 105rem;
      height: 105rem;
    }
  }

  &--large {
    height: 100%;
    min-height: auto;
    position: relative;
    margin-bottom: $spacing-16;
    padding-bottom: 64px;
    background-color: $color-primary-200;

    @media (min-width: $breakpoint-sm) {
      margin-bottom: $spacing-96;
      padding-bottom: 0;
      min-height: 45rem;
      height: 45rem;
    }
    &.fifteen-hero__background {
      background-position: 67% 80px;
      background-repeat: no-repeat;
      background-size: 265%;

      @media (min-width: $breakpoint-sm) {
        background-size: cover;
        background-position: center;
        background-repeat: no-repeat;
      }
    }
    .fifteen-hero__row {
      flex-direction: column;
      @media (min-width: $breakpoint-sm) {
        flex-direction: row-reverse;
      }
      & > :first-child {
        display: block !important;
        padding-bottom: 185%;
        @media (min-width: $breakpoint-sm) {
          padding-bottom: 0;
        }
      }
    }
    .slp-flex {
      display: flex;
      flex-wrap: wrap;
      justify-content: flex-start;
    }
    .fifteen-hero__title {
      &-image {
        width: 100%;
        flex: 1 0 100%;
        img {
          width: 89%;
          height: auto;
          max-width: 100%;
          @media (min-width: $breakpoint-sm) {
            width: 31%;
          }
          @media (min-width: $breakpoint-md) {
            width: 71%;
          }
        }
      }
    }
  }

  &__body {
    &--seventeen {
      margin-top: -$spacing-96;
      max-width: 85%;

      @media (max-width: $breakpoint-sm) {
        margin-top: $spacing-96;
      }
    }
  }

  &__background {
    background-position: center;
    background-repeat: no-repeat;
    background-size: auto;

    @media (min-width: $breakpoint-md) {
      background-size: cover;
      background-position: center;
    }

    &--seventeen {
      background-position: center top;
      background-repeat: no-repeat;
      background-size: cover;

      @media (min-width: $breakpoint-md) {
        background-position: center bottom;
      }
    }
  }

  &__image {
    max-width: 15rem;

    &--seventeen {
      max-width: fit-content;
    }
  }

  &__action {
    padding: 0;
  }

  &__header {
    font-weight: 600;

    @media (min-width: $breakpoint-md) {
      font-size: 90px;
    }

    &--seventeen {
      font-size: $spacing-96;
      font-weight: 800;
      line-height: 100px;

      @media (max-width: $breakpoint-sm) {
        font-size: $spacing-48;
        line-height: $spacing-48;
      }
    }
  }

  &__subtitle {
    &--seventeen {
      @media (min-width: $breakpoint-md) {
        max-width: 90%;
      }
    }
  }

  &__note {
    -webkit-text-fill-color: transparent;
    background: linear-gradient(
      91.08deg,
      #f9a026 -9.03%,
      #bc8dbc 21.23%,
      #a686f2 35.46%,
      #592ac8 65.98%
    );
    -webkit-background-clip: text;
    -moz-background-clip: text;
    background-clip: text;
  }

  .fifteen-hero__row {
    & > :first-child {
      display: none;
    }

    &--seventeen {
      align-items: flex-start;
      // Padding top for pushing down text vs. background img
      @media (max-width: $breakpoint-sm) {
        padding-top: 396px;
      }
      @media (min-width: $breakpoint-sm) and (max-width: $breakpoint-md) {
        padding-top: 50rem;
      }
      // Padding for spacing up hero
      @media (min-width: $breakpoint-md) and (max-width: $breakpoint-xl) {
        padding: $spacing-32 $spacing-16;
      }
    }
  }
}
</style>
